// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;
using System.Collections;

namespace LoCoL.Logs
{
	/// <summary>
	/// ,   .
	/// </summary>
	public class DefaultLogDetailer : ILogDetailer
	{

		#region Public Constructor

		/// <summary>
		/// .
		/// </summary>
		public DefaultLogDetailer( bool isDefaultAutomaonEnabled )
		{
			m_Automaton = new Hashtable();
			m_Object = new object();
			m_IsDefaultAutomaonEnabled = isDefaultAutomaonEnabled;
			m_EnabledBeginCycle = true;
			m_EnabledBeginNotificationProcessing = true;
			m_EnabledInputInquire = true;
			m_EnabledNotificationChecking = true;
			m_EnabledStateChecking = true;
			m_EnabledTransition = true;
			m_EnabledOutputInvocation = true;
			m_EnabledSendMessage = true;
			m_EnabledEndNotificationProcessing = true;
			m_EnabledEndCycle = true;
		}

		#endregion

		#region Private Members

		/// <summary>
		/// ,  / ( 
		///   <see cref="m_IsDefaultAutomaonEnabled"/>).
		/// </summary>
		private Hashtable m_Automaton;

		/// <summary>
		///    
		///     <see cref="m_Automaton"/>.
		/// </summary>
		private object m_Object;

		/// <summary>
		///     -.
		/// </summary>
		private bool m_IsDefaultAutomaonEnabled;

		/// <summary>
		/// / 
		///     .
		/// </summary>
		private bool m_EnabledBeginCycle;

		/// <summary>
		/// /   
		///  .
		/// </summary>
		private bool m_EnabledBeginNotificationProcessing;

		/// <summary>
		/// /   
		///   .
		/// </summary>
		private bool m_EnabledInputInquire;

		/// <summary>
		/// /   
		///   .
		/// </summary>
		private bool m_EnabledNotificationChecking;

		/// <summary>
		/// /   
		///      .
		/// </summary>
		private bool m_EnabledStateChecking;

		/// <summary>
		/// /   
		///  .
		/// </summary>
		private bool m_EnabledTransition;

		/// <summary>
		/// /   
		///   .
		/// </summary>
		private bool m_EnabledOutputInvocation;

		/// <summary>
		/// /   
		///  .
		/// </summary>
		private bool m_EnabledSendMessage;

		/// <summary>
		/// /   
		///    .
		/// </summary>
		private bool m_EnabledEndNotificationProcessing;

		/// <summary>
		/// /   
		///    .
		/// </summary>
		private bool m_EnabledEndCycle;

		#endregion

		#region Public Methods

		/// <summary>
		/// /   .
		/// </summary>
		public void EnableAutomaton( int automatonNo, bool enable )
		{
			if ( IsDefaultAutomaonEnabled == enable )
			{
				m_Automaton.Remove( automatonNo );
			}
			else
			{
				m_Automaton.Add( automatonNo, m_Object );
			}
		}

		/// <summary>
		///     .
		/// </summary>
		public bool IsEnabledAutomaton( int automatonNo )
		{
			return 
				m_Automaton.ContainsKey( automatonNo ) ^
				IsDefaultAutomaonEnabled;
		}

		#endregion

		#region Public Properties

		/// <summary>
		///     -.
		/// </summary>
		public bool IsDefaultAutomaonEnabled
		{
			get
			{
				return m_IsDefaultAutomaonEnabled;
			}
		}


		/// <summary>
		/// /   
		///   .
		/// </summary>
		public bool IsEnabledBeginCycle
		{
			get
			{
				return m_EnabledBeginCycle;
			}
			set
			{
				m_EnabledBeginCycle = value;
			}
		}

		/// <summary>
		/// /   
		///  .
		/// </summary>
		public bool IsEnabledBeginNotificationProcessing
		{
			get
			{
				return m_EnabledBeginNotificationProcessing;
			}
			set
			{
				m_EnabledBeginNotificationProcessing = value;
			}
		}

		/// <summary>
		/// /   
		///   .
		/// </summary>
		public bool IsEnabledInputInquire
		{
			get
			{
				return m_EnabledInputInquire;
			}
			set
			{
				m_EnabledInputInquire = value;
			}
		}

		/// <summary>
		/// /   
		///   .
		/// </summary>
		public bool IsEnabledNotificationChecking
		{
			get
			{
				return m_EnabledNotificationChecking;
			}
			set
			{
				m_EnabledNotificationChecking = value;
			}
		}

		/// <summary>
		/// /   
		///      .
		/// </summary>
		public bool IsEnabledStateChecking
		{
			get
			{
				return m_EnabledStateChecking;
			}
			set
			{
				m_EnabledStateChecking = value;
			}
		}

		/// <summary>
		/// /   
		///  .
		/// </summary>
		public bool IsEnabledTransition
		{
			get
			{
				return m_EnabledTransition;
			}
			set
			{
				m_EnabledTransition = value;
			}
		}

		/// <summary>
		/// /   
		///   .
		/// </summary>
		public bool IsEnabledOutputInvocation
		{
			get
			{
				return m_EnabledOutputInvocation;
			}
			set
			{
				m_EnabledOutputInvocation = value;
			}
		}

		/// <summary>
		/// /   
		///  .
		/// </summary>
		public bool IsEnabledSendMessage
		{
			get
			{
				return m_EnabledSendMessage;
			}
			set
			{
				m_EnabledSendMessage = value;
			}
		}

		/// <summary>
		/// /   
		///    .
		/// </summary>
		public bool IsEnabledEndNotificationProcessing
		{
			get
			{
				return m_EnabledEndNotificationProcessing;
			}
			set
			{
				m_EnabledEndNotificationProcessing = value;
			}
		}

		/// <summary>
		/// /   
		///    .
		/// </summary>
		public bool IsEnabledEndCycleg
		{
			get
			{
				return m_EnabledEndCycle;
			}
			set
			{
				m_EnabledEndCycle = value;
			}
		}

		#endregion

		#region ILogDetailer Implementation

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool ILogDetailer.IsEnabledBeginCycle( AutomatonManager manager )
		{
			return IsEnabledBeginCycle;
		}

		/// <summary>
		/// ,   
		///     .
		/// </summary>
		bool ILogDetailer.IsEnabledBeginNotificationProcessing(
			Automaton automaton,
			Notification notification )
		{
			return IsEnabledAutomaton( automaton.ID ) &&
				IsEnabledBeginNotificationProcessing;
		}

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool ILogDetailer.IsEnabledInputInquire(
			Automaton automaton,
			InputVariable variable )
		{
			return IsEnabledAutomaton( automaton.ID ) &&
				IsEnabledInputInquire;
		}

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool ILogDetailer.IsEnabledNotificationChecking(
			Automaton automaton,
			Notification notification )
		{
			return IsEnabledAutomaton( automaton.ID ) &&
				IsEnabledNotificationChecking;
		}

		/// <summary>
		/// ,   
		///      .
		/// </summary>
		bool ILogDetailer.IsEnabledStateChecking(
			Automaton automaton,
			Automaton checkedAutomaton,
			State state )
		{
			return IsEnabledAutomaton( automaton.ID ) &&
				IsEnabledStateChecking;
		}

		/// <summary>
		/// ,   
		///  .
		/// </summary>
		bool ILogDetailer.IsEnabledTransition(
			Automaton automaton,
			Transition transition )
		{
			return IsEnabledAutomaton( automaton.ID ) &&
				IsEnabledTransition;
		}

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool ILogDetailer.IsEnabledOutputInvocation(
			Automaton automaton,
			OutputAction action )
		{
			return IsEnabledAutomaton( automaton.ID ) &&
				IsEnabledOutputInvocation;
		}

		/// <summary>
		/// ,   
		///  .
		/// </summary>
		bool ILogDetailer.IsEnabledSendMessage(
			Automaton targetAutomaton,
			Notification notification )
		{
			return IsEnabledAutomaton( targetAutomaton.ID ) &&
				IsEnabledSendMessage;
		}

		/// <summary>
		/// ,   
		///    .
		/// </summary>
		bool ILogDetailer.IsEnabledEndNotificationProcessing(
			Automaton automaton,
			Notification notification )
		{
			return IsEnabledAutomaton( automaton.ID ) &&
				IsEnabledEndNotificationProcessing;
		}

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool ILogDetailer.IsEnabledEndCycle( AutomatonManager manager )
		{
			return IsEnabledEndNotificationProcessing;
		}

		#endregion
	}
}
