// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;
using System.Runtime.Serialization;

using LoCoL.Conditions;

namespace LoCoL
{
	/// <summary>
	///  .
	/// </summary>
	[Serializable]
	public class InputVariable : NamedObject, ISerializable
	{

		#region Public Constructor

		/// <summary>
		/// .
		/// </summary>
		public InputVariable( int id, string name )
			: base( id, name )
		{
		}

		#endregion

		#region ISerializable Implementation

		/// <summary>
		///  .
		/// </summary>
		protected InputVariable(
			SerializationInfo info,
			StreamingContext context )
			: base( info, context )
		{
		}

		/// <summary>
		///    .
		/// </summary>
		public override void GetObjectData(
			SerializationInfo info,
			StreamingContext context )
		{
			base.GetObjectData( info, context );
		}

		#endregion

		#region Overrided Methods

		/// <summary>
		///    .
		/// </summary>
		public override string ToString()
		{
			return "x" + base.ToString();
		}

		#endregion

		#region Operators

		/// <summary>
		///   AND     Condition.
		/// </summary>
		public static Condition operator &( InputVariable v, Condition c )
		{
			return (Condition)v & c;
		}

		/// <summary>
		///   OR     Condition.
		/// </summary>
		public static Condition operator |( InputVariable v, Condition c )
		{
			return (Condition)v | c;
		}

		/// <summary>
		///   XOR     Condition.
		/// </summary>
		public static Condition operator ^( InputVariable v, Condition c )
		{
			return (Condition)v ^ c;
		}

		/// <summary>
		///   NOT     Condition.
		/// </summary>
		public static Condition operator !( InputVariable v )
		{
			return !(Condition)v;
		}

		#endregion

		#region Implicit Conversions

		/// <summary>
		///     <see cref="CheckInputVariable"/>.
		/// </summary>
		public static implicit operator CheckInputVariable(
			InputVariable variable )
		{
			return new CheckInputVariable( variable.ID );
		}

		#endregion

	}
}

