// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;
using System.Runtime.Serialization;

namespace LoCoL
{
	/// <summary>
	///  .
	///  ID  .
	///       .
	/// </summary>
	[Serializable]
	public abstract class NamedObject : ISerializable
	{

		#region Protected Constructor

		/// <summary>
		/// .
		/// </summary>
		protected NamedObject( int id, string name )
		{
			m_ID = id;
			m_Name = name;
			if ( m_Name == null || m_Name == "" )
			{
				m_Name = "Noname";
			}
		}

		#endregion

		#region ISerializable Implementation

		/// <summary>
		///  .
		/// </summary>
		protected NamedObject(
			SerializationInfo info,
			StreamingContext context )
		{
			m_ID = (int)info.GetValue( "ID", typeof(int) );
			m_Name = (string)info.GetValue( "Name", typeof(string) );
		}

		/// <summary>
		///    .
		/// </summary>
		public virtual void GetObjectData(
			SerializationInfo info,
			StreamingContext context )
		{
			info.AddValue( "ID", m_ID );
			info.AddValue( "Name", m_Name );
		}

		#endregion

		#region Private Members

		/// <summary>
		/// ID.
		/// </summary>
		private int m_ID;

		/// <summary>
		/// .
		/// </summary>
		private string m_Name;

		#endregion

		#region Public Properties

		/// <summary>
		/// ID.
		/// </summary>
		public int ID
		{
			get
			{
				return m_ID;
			}
		}

		/// <summary>
		/// .
		/// </summary>
		public string Name
		{
			get
			{
				return m_Name;
			}
		}

		#endregion

		#region Overrided Methods

		/// <summary>
		///       ID(Name).
		/// </summary>
		public override string ToString()
		{
			return ID.ToString() + "(" + Name + ")";
		}

		/// <summary>
		///    .
		/// </summary>
		public override bool Equals( object obj )
		{
			NamedObject namedObj = obj as NamedObject;
			if ( obj == null )
			{
				return false;
			}
			return ( this.m_ID == namedObj.m_ID ) &&
				( this.m_Name == namedObj.m_Name );
		}

		/// <summary>
		///  Hash-  .
		/// </summary>
		public override int GetHashCode()
		{
			return m_ID.GetHashCode()*9 ^ m_Name.GetHashCode()*11;
		}

		#endregion

	}
}
