// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;
using System.Reflection;
using System.Runtime.Serialization;

using LoCoL.Exceptions;

namespace LoCoL
{
	/// <summary>
	///  .
	/// </summary>
	[Serializable]
	public class OutputAction : NamedObject, IAutomatonAction, ISerializable
	{

		#region Public Constructor

		/// <summary>
		/// .
		/// </summary>
		public OutputAction( int id, string name )
			: base( id, name )
		{
		}

		#endregion

		#region ISerializable Implementation

		/// <summary>
		///  .
		/// </summary>
		protected OutputAction(
			SerializationInfo info,
			StreamingContext context )
			: base( info, context )
		{
		}

		/// <summary>
		///    .
		/// </summary>
		public override void GetObjectData(
			SerializationInfo info,
			StreamingContext context )
		{
			base.GetObjectData( info, context );
		}

		#endregion

		#region IAutomatonAction Implementation

		/// <summary>
		///    ( ) 
		///  <c>automaton</c>.
		/// </summary>
		public void DoAction( Automaton automaton )
		{
			automaton.DoOutputInvocation( this.ID );
		}

		#endregion

		#region IValidCheckable Implementation

		/// <summary>
		///    .
		/// </summary>
		/// <param name="args"> Automaton.</param>
		/// <exception cref="CheckValidException">
		/// <list>
		/// <item><description>
		///      <see cref="Automaton"/>.
		/// </description></item>
		/// <item><description>
		///        ID.
		/// </description></item>
		/// </list>
		/// </exception>
		public void CheckValid( params object[] args )
		{
			if ( args.Length != 1 || !( args[ 0 ] is Automaton ) )
			{
				throw new CheckValidException( " " + 
					this.GetType().Name + "." +
					MethodInfo.GetCurrentMethod().Name + 
					"     Automaton." );
			}
			Automaton a = (Automaton)args[ 0 ];
			if ( a.OutputActions[ this.ID ] == null )
			{
				throw new CheckValidException( " " + a.ToString() +
					"      ID==" +
					this.ID + "." );
			}
		}

		#endregion

	}
}
