// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;
using System.Collections;
using System.Runtime.Serialization;

namespace LoCoL.Collections
{
	/// <summary>
	///   .
	/// </summary>
	[Serializable]
	public class OutputActionSet : IEnumerable, IChangeable, ISerializable
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public OutputActionSet()
		{
			m_Set = new NamedObjectSet();
			m_Set.Changed += new ChangedEventHandler( RaiseChangedEvent );
		}

		/// <summary>
		///  .
		/// </summary>
		public OutputActionSet( OutputActionSet actions )
		{
			m_Set = actions.m_Set.Clone();
			m_Set.Changed += new ChangedEventHandler( RaiseChangedEvent );
		}

		#endregion

		#region ISerializable Implementation

		/// <summary>
		///  .
		/// </summary>
		protected OutputActionSet(
			SerializationInfo info,
			StreamingContext context )
		{
			m_Set = (NamedObjectSet)info.GetValue(
				"Value",
				typeof(NamedObjectSet) );
			m_Set.Changed += new ChangedEventHandler( RaiseChangedEvent );
		}

		/// <summary>
		///    .
		/// </summary>
		public virtual void GetObjectData(
			SerializationInfo info,
			StreamingContext context )
		{
			info.AddValue( "Value", m_Set );
		}

		#endregion

		#region Private Members

		/// <summary>
		///    .
		/// </summary>
		private NamedObjectSet m_Set;

		#endregion

		#region Public Methods

		/// <summary>
		///  .
		/// </summary>
		public OutputActionSet Clone()
		{
			return new OutputActionSet( this );
		}

		/// <summary>
		///  .
		/// </summary>
		public void Clear()
		{
			m_Set.Clear();
		}

		/// <summary>
		///   .
		/// </summary>
		public void Add( OutputAction action )
		{
			m_Set.Add( action );
		}

		/// <summary>
		/// ,      .
		/// </summary>
		public bool Contains( OutputAction action )
		{
			return m_Set.Contains( action );
		}

		/// <summary>
		///     .
		///    ,  .
		/// </summary>
		public void Remove( OutputAction action )
		{
			m_Set.Remove( action );
		}

		#endregion

		#region Public Properties

		/// <summary>
		///      ID.
		/// ID -    ,
		///      .
		/// </summary>
		public OutputAction this[ int id ]
		{
			get
			{
				return (OutputAction)m_Set[ id ];
			}
		}

		/// <summary>
		///    .
		/// </summary>
		public int Count
		{
			get
			{
				return m_Set.Count;
			}
		}

		#endregion

		#region IEnumerable Implementation

		/// <summary>
		/// Enumerator.
		/// </summary>
		public IEnumerator GetEnumerator()
		{
			return m_Set.GetEnumerator();
		}

		#endregion

		#region IChangeable Implementation

		/// <summary>
		/// , ,     .
		/// </summary>
		public event ChangedEventHandler Changed;

		private void RaiseChangedEvent( object sender, ChangedEventArgs e )
		{
			if ( Changed != null )
			{
				Changed( this, e );
			}
		}

		#endregion

	}
}
