// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;
using System.IO;
using System.Runtime.Serialization.Formatters.Soap;

using LoCoL;
using LoCoL.Collections;
using LoCoL.Conditions;

namespace LoCoL_Demo_Create
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			AutomatonManager am = new AutomatonManager();

			InputVariable x0 =
				new InputVariable( 0, "  - " );
			InputVariable x1 =
				new InputVariable( 1, "  - " );
			InputVariable x2 =
				new InputVariable( 2, "  - " );
			OutputAction z2 =
				new OutputAction( 2, "   " );
			OutputAction z3 =
				new OutputAction( 3, "  " );
			OutputAction z4 =
				new OutputAction( 4, "   " );
			OutputAction z5 =
				new OutputAction( 5, "    " );
			OutputAction z6 =
				new OutputAction( 6, "    " );
			OutputAction z7 =
				new OutputAction( 7, "  " );
			OutputAction z9 =
				new OutputAction( 9, " " );

			Automaton a1 = new Automaton( 1, " " );
			a1.InputVariables.Add( x0 );
			a1.InputVariables.Add( x1 );
			a1.InputVariables.Add( x2 );
			a1.OutputActions.Add( z3 );
			a1.OutputActions.Add( z4 );
			a1.OutputActions.Add( z5 );
			a1.OutputActions.Add( z6 );
			a1.States.Add( new State( 0, " " ) );
			a1.States.Add( new State( 1, "" ) );
			a1.States.Add( new State( 2, "" ) );
			a1.States.Add( new State( 3, "" ) );
			a1.Transitions.Add( new Transition( 0, "0->0", 0, 0 ) );
			a1.Transitions[ 0 ].Condition = x0;
			a1.Transitions.Add( new Transition( 1, "0->1", 0, 1 ) );
			a1.Transitions[ 1 ].Condition = !x0 & !x1 & !x2;
			a1.Transitions[ 1 ].Actions.Add( z3 );
			a1.Transitions.Add( new Transition( 2, "0->2", 0, 2 ) );
			a1.Transitions[ 2 ].Condition = x2;
			a1.Transitions[ 2 ].Actions.Add( z3 );
			a1.Transitions.Add( new Transition( 3, "0->3", 0, 3 ) );
			a1.Transitions[ 3 ].Condition = x1;
			a1.Transitions[ 3 ].Actions.Add( z4 );
			a1.Transitions.Add( new Transition( 4, "1->0", 1, 0 ) );
			a1.Transitions[ 4 ].Condition = x0;
			a1.Transitions.Add( new Transition( 5, "1->1", 1, 1 ) );
			a1.Transitions[ 5 ].Condition = !x0 & !x2;
			a1.Transitions[ 5 ].Actions.Add( z3 );
			a1.Transitions.Add( new Transition( 6, "1->2", 1, 2 ) );
			a1.Transitions[ 6 ].Condition = x2;
			a1.Transitions[ 6 ].Actions.Add( z3 );
			a1.Transitions.Add( new Transition( 7, "2->0", 2, 0 ) );
			a1.Transitions[ 7 ].Condition = x0;
			a1.Transitions.Add( new Transition( 8, "2->1", 2, 1 ) );
			a1.Transitions[ 8 ].Condition = !x0 & !x1 & !x2;
			a1.Transitions[ 8 ].Actions.Add( z3 );
			a1.Transitions.Add( new Transition( 9, "2->2", 2, 2 ) );
			a1.Transitions[ 9 ].Condition = x2;
			a1.Transitions[ 9 ].Actions.Add( z3 );
			a1.Transitions.Add( new Transition( 10, "2->3", 2, 3 ) );
			a1.Transitions[ 10 ].Condition = x1;
			a1.Transitions[ 10 ].Actions.Add( z4 );
			a1.Transitions.Add( new Transition( 11, "3->0", 3, 0 ) );
			a1.Transitions[ 11 ].Condition = x0;
			a1.Transitions[ 11 ].Actions.Add( z5 );
			a1.Transitions.Add( new Transition( 12, "3->1", 3, 1 ) );
			a1.Transitions[ 12 ].Condition = !x0 & !x1 & !x2;
			a1.Transitions[ 12 ].Actions.Add( z6 );
			a1.Transitions[ 12 ].Actions.Add( z3 );
			a1.Transitions.Add( new Transition( 13, "3->2", 3, 2 ) );
			a1.Transitions[ 13 ].Condition = x2;
			a1.Transitions[ 13 ].Actions.Add( z5 );
			a1.Transitions[ 13 ].Actions.Add( z3 );
			a1.Transitions.Add( new Transition( 14, "3->3", 3, 3 ) );
			a1.Transitions[ 14 ].Condition = x1;
			a1.Transitions[ 14 ].Actions.Add( z4 );

			Automaton a2 = new Automaton( 2, " " );
			a2.InputVariables.Add( x0 );
			a2.InputVariables.Add( x2 );
			a2.OutputActions.Add( z7 );
			a2.States.Add( new State( 0, " " ) );
			a2.States.Add( new State( 1, "" ) );
			a2.Transitions.Add(
				new Transition( 0, "   ", 0, 0 ) );
			a2.Transitions[ 0 ].Condition = x0 | x2;
			a2.Transitions.Add( new Transition( 1, " ", 0, 1 ) );
			a2.Transitions[ 1 ].Condition = !x0 & !x2;
			a2.Transitions[ 1 ].Actions.Add( z7 );
			a2.Transitions.Add( new Transition( 2, "  ", 1, 1 ) );
			a2.Transitions[ 2 ].Condition = !x2;
			a2.Transitions.Add( new Transition( 3, " ", 1, 0 ) );
			a2.Transitions[ 3 ].Condition = x2;

			Automaton a0 = new Automaton( 0, " " );
			a0.InputVariables.Add( x0 );
			a0.OutputActions.Add( z2 );
			a0.OutputActions.Add( z9 );
			a0.States.Add( new State( 0, " " ) );
			a0.States.Add( new State( 1, " " ) );
			a0.States[ 1 ].Actions.Add( z9 );
			a0.Transitions.Add(
				new Transition( 0, "   ", 0, 0 ) );
			a0.Transitions[ 0 ].Condition = !x0;
			a0.Transitions[ 0 ].Actions.Add( a1 );
			a0.Transitions[ 0 ].Actions.Add( a2 );
			a0.Transitions[ 0 ].Actions.Add( z2 );
			a0.Transitions.Add(
				new Transition( 1, "  ", 0, 1 ) );
			a0.Transitions[ 1 ].Condition = x0;
			a0.Transitions[ 1 ].Actions.Add( a1 );
			a0.Transitions[ 1 ].Actions.Add( a2 );

			am.Automatons.Add( a0 );
			am.Automatons.Add( a1 );
			am.Automatons.Add( a2 );

			SoapFormatter formatter = new SoapFormatter();
			Stream stream = File.Create( "AutomatonManager.soap" );
			formatter.Serialize( stream, am );
			stream.Close();
		}
	}
}
